<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;

use App\Http\Base\BaseModel;

class AdjustmentbbmModel extends BaseModel
{
	/**
	 * table name from database
	 */
	protected $table = "adjustmentbbm";

	/**
	 *   alias table for relation issues
	 */
	protected $aliasTable = "adjustmentbbm";

	/**
	 * primary key from table remember eloquent doesnt support composite primary key
	 */
	protected $primaryKey = "id";
	/**
	 * check the incrementing boolean if the incrementing from database is false then the value is false by default
	 */
	// public $incrementing = false;
	/**
	 * fillable property for eloquent attribute cast
	 */
	protected $fillable = [
		"id", "transactionNo", "userId",
		"kapalId", "locationId", "keterangan", "transactionDate",
		"voyageKode",
		"voyageName",
		"voyageStart",
		"voyageEnd",
		"itemId", "quantity", "sisaawal",
		"namaItem",
		"deskripsi",
		"lotNumber",
		"pelabuhan",
		"date_updated",
		"is_sync"
	];
	/**
	 * Creating raw object from table that, this purpose for making you easier for remembering all attribute
	 */


	/**
	 * paging for default paging purpose
	 * if you want to add new paging property you have to add the property in this array
	 * you have to add the relation value
	 * remember this is not suported casting value you have to handle by your self
	 */
	protected $aliasPaging = [
		"date" => "adjustmentbbm.date",
		"transactionDate" => "adjustmentbbm.transactionDate",
		"transactionNo" => "adjustmentbbm.transactionNo",
		"voyageStart" => "adjustmentbbm.voyageStart",
		"voyageEnd" => "adjustmentbbm.voyageEnd",
		"voyageKode" => "adjustmentbbm.voyageKode"
	];

	/**
	 * relation from ' . kapal . ' by ' . kapalId 
	 * join kapal on kapal.id = adjustmentbbm.kapalId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationKapalId($alias = "kapalId")
	{
		$this->getQuery()->join("kapal as $alias", "$alias.id", "=", "adjustmentbbm.kapalId");
		return $this;
	}
	/**
	 * relation from ' . lokasiitem . ' by ' . locationId 
	 * join lokasiitem on lokasiitem.id = adjustmentbbm.locationId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationLocationId($alias = "locationId")
	{
		$this->getQuery()->join("lokasiitem as $alias", "$alias.id", "=", "adjustmentbbm.locationId");
		return $this;
	}
	/**
	 * relation from ' . users . ' by ' . userId 
	 * join users on users.id = adjustmentbbm.userId
	 * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
	 * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
	 * @param string $alias
	 * @return $this
	 */
	public function joinRelationUserId($alias = "users")
	{
		$this->getQuery()->join("users as $alias", "$alias.id", "=", "adjustmentbbm.userId");
		return $this;
	}

	public function joinRelationVoyageKode($alias = "voyageKode")
	{
		$this->getQuery()->leftjoin("voyages as $alias", function ($join) use ($alias) {
			$join->on("$alias.voyageKode", "=", "adjustmentbbm.voyageKode");
			$join->on("$alias.kapalId", "=", "adjustmentbbm.kapalId");
		});
		return $this;
	}


	public function updateTransactionSyncFlag($TRANSACTION_NUM, $ITEM_ID, $LOT_NUMBER)
	{
		$model = (new self())->getQuery()->where("adjustmentbbm.transactionNo", "=", $TRANSACTION_NUM)
			->where("adjustmentbbm.itemId", "=", $ITEM_ID)
			->where("adjustmentbbm.lotNumber", "=", $LOT_NUMBER)->first();
		if ($model) {
			$model = self::find($model->id);
			$model->is_sync = 1;
			$model->update();
			// (new LogsynckapalModel)->setLogSync("Update Sync Flag Transfer IO: " . $TRANSACTION_NUM . " - " . $LOT_NUMBER . " - " . $LOT_NUMBER, Carbon::now()->toDateTimeString(), "", "updated");
		}
	}

	// RETURN NUMBER OF ROWS AS INTEGER, FOR ITEMS WITH LOT_NUMBER AND IS_SYNC IS NULL
	public function validUpdateStock($ITEM_ID, $LOT_NUMBER)
	{
		$model = (new self())->getQuery()
			->selectRaw('COUNT("adjustmentbbm"."itemId") as "nItems"')
			->where("adjustmentbbm.itemId", "=", $ITEM_ID)
			->where("adjustmentbbm.lotNumber", "=", $LOT_NUMBER)
			->whereNull("adjustmentbbm.is_sync")
			->groupBy("itemId")
			->first();
		if ($model) {
			return $model->nItems;
		} else {
			return 0;
		}
	}
}
